
/*	Quick and dirty converter ZX Spectrum .tape -> .tap files
	Userinterface: drag&drop only
	(c) copyright 1995 G. Woigk

	This file is part of Mac Spectacle and it is free software
	See Application.c for details
			
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

	21.Jan.95		first and probably final version			(KIO !)
	25.Feb.95		recompiled using CodeWarrior				(KIO !)
*/


#include	<dialogs.h>
#include	<files.h>
#include	<strings.h>
#include	"kio.h"
#include	"mem.h"


#define alertID		666	// 'ALRT' resourceID


		short	DoBox ( short id, Str255 s, Str255 t, Str255 u );
void			InitHighLevelEvents(void);
void			HandleAppleMenu(long itemNum);
void			HandleMenuSelection(long menuResult);
void			HandleMouseDown(void);
		OSErr	MyGotRequiredParams ( AppleEvent *theAppleEvent );
pascal	OSErr	HandleOpenAPP(AppleEvent *eventIn, AppleEvent *eventOut, long refCon);
pascal 	OSErr	HandleQuitAPP(AppleEvent *eventIn, AppleEvent *eventOut, long refCon);
		OSErr	OpenAppl (AppleEvent *eventIn, long how);
pascal 	OSErr	HandleOpenDOC(AppleEvent *eventIn, AppleEvent *eventOut, long refCon);
pascal 	OSErr	HandlePrintDOC(AppleEvent *eventIn, AppleEvent *eventOut, long refCon);

void			DoAbort ( Str255 s, Str255 t, Str255 u );
void			ShowHelp ( void );
void			HandleOPEN ( FSSpec file );


EventRecord	event;			// event returned by WaitNextEvent
Boolean		done;			// Abbruchkriterium fr Event-Warteschleife


// ****************************************************************************


// 	********************************************
//	***** CONVERT A SINGLE FILE: .tape --> .tap
//	********************************************

void HandleOPEN ( FSSpec sourceSpec )
{	Handle	h;
	short	source, temp;
	FSSpec	tempSpec = { 0, 0, "\ptape converter .temp" };
	OSErr	err;
	long	sourceLen,n,destLen;
	Str63	s;
	Char	*q,*z,*e;
	FInfo	fndrInfo;

// open source file, allocate buffer; read source file; and close source file
	
	err = FSpOpenDF (&sourceSpec, fsCurPerm, &source);
	if (err) { NumToString(err,s); DoAbort(sourceSpec.name,"\pcould not be opened",s); };

	err = GetEOF (source, &sourceLen);
	if (err) { NumToString(err,s); DoAbort(sourceSpec.name,"\pcould not read file length",s); };

	h = TempNewHandle (sourceLen, &err);
	if (err) { DoAbort("\ptemporary memory could not be allocated","\p","\p"); };
	HLock ( h );

	err = FSRead (source, &sourceLen, *h);
	if (err) { NumToString(err,s); DoAbort(sourceSpec.name,"\pcould not be read",s); };
	FSClose (source);

// convert buffer

	q=z=*(Char**)h;
	if ( *(long*)q != *(long*)"TAPE" ) DoAbort(sourceSpec.name,"\pwrong header format","\p");
	n = *(long*)(q+4); if (n>sourceLen||n<12)  DoAbort(sourceSpec.name,"\plogical tape length exceeds file length","\p");
	e=q+n;
	q+=12;
	
	while ( q<e )
	{	if ( *(long*)q != *(long*)"data" ) DoAbort(sourceSpec.name,"\pwrong header format","\p");
		n = *(long*)(q+4); if (q+n>e||n<=8)  DoAbort(sourceSpec.name,"\psub block length exceeds tape length","\p");
		n -= 8;
		q += 8;
		*z++ = n; *z++ = n>>8;
		memmove ( z, q, n );
		q += (n+3)&0xfffffffc;
		z += n;
	};
	
	destLen = z-*(Char**)h;
	
// create and open temp file; write buffer to temp file, and close temp file
	
	tempSpec.vRefNum = sourceSpec.vRefNum;		// same volume --> exchange files
	tempSpec.parID   = sourceSpec.parID;		// same directory 

	err = FSpCreate ( &tempSpec, '????', 'TEMP', -1 ); if (err==dupFNErr) err=noErr;
	if (err) { NumToString(err,s); DoAbort("\pError creating temp file",s,"\p"); };
		
	err = FSpOpenDF ( &tempSpec, fsWrPerm, &temp );
	if (err) { NumToString(err,s); DoAbort("\pError opening temp file",s,"\p"); };
	
	err = FSWrite (temp, &destLen, *h);
	if (err) { NumToString(err,s); DoAbort("\pError writing to temp file",s,"\p"); };
	FSClose ( temp ); temp=0;	

// swap temp file and source file, erase temp file and discard buffer

	err = FSpExchangeFiles (&tempSpec, &sourceSpec);	
	if (err) { NumToString(err,s); DoAbort("\ptemp file could not be swapped with source file",s,"\p"); }

	FSpDelete ( &tempSpec );
	DisposHandle ( h );
	
// modify file type

	err = FSpGetFInfo (&sourceSpec, &fndrInfo);
	if (err) { NumToString(err,s); DoAbort(sourceSpec.name,"\pcould not modify file type",s); }
	fndrInfo.fdType = 'Tape';
	err = FSpSetFInfo (&sourceSpec, &fndrInfo);
}



// ***** STANDARD DIALOGE ***************************************** 

void DoAbort ( Str255 s, Str255 t, Str255 u ) 
{	long n;
	ParamText(s,t,u,0);
	n = StopAlert ( alertID, nil );
	if (n<0) { SysBeep(20);SysBeep(20);SysBeep(20);SysBeep(20); }
	ExitToShell();
}


void ShowHelp()
{	DoAbort ( "\pThis program converts the no longer supported ZX Spectrum .tape files to the .tap format supported by many ZX Spectrum emulators.",
			  "\pThe file is replaced instantly without further note. If the icon was missing, it will reapear immediately or maybe after restart of your Mac.",
			  "\pThe only interface for this application is DRAG & DROP (System 7.0 or higher required)" 
			);
}


main()
{	short i;

	InitGraf((Ptr) &qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	FlushEvents(everyEvent,0);
	TEInit();
	InitDialogs(0L);
	InitCursor();
	InitHighLevelEvents();

	done = false;

	for (i=100;i&&!done;i--)
		if ( WaitNextEvent(everyEvent,&event,0,nil))
			switch (event.what)
			{
			case kHighLevelEvent:				// the only event we are interested in
				AEProcessAppleEvent(&event);	// is AppleEvent 'ODOC' via drag&drop
				break;	
			default:		
				SysBeep(20);					
				break;
			};

	return 0;
}


// ****************************
// ***** High Level Apple Event
// ****************************

OSErr MyGotRequiredParams ( AppleEvent *theAppleEvent )
{	DescType	returnedType;
	Size		actualSize;
	OSErr		err;

	err = AEGetAttributePtr ( theAppleEvent, keyMissedKeywordAttr, typeWildCard, 
							  &returnedType, nil, 0, &actualSize);
	if (err==errAEDescNotFound)	return noErr;	// you got all the required parameters
	if (err==noErr) return errAEParamMissed;	// you missed a required parameter	
	return err;									// the call to AEGetAttributePtr failed
}


pascal OSErr HandleOpenAPP(AppleEvent *eventIn, AppleEvent *eventOut, long refCon)
{	OSErr	err;
	err = MyGotRequiredParams ( eventIn ); 
	ShowHelp();
	return err; 
}


pascal OSErr HandleQuitAPP(AppleEvent *eventIn, AppleEvent *eventOut, long refCon)
{	OSErr	err;
	err = MyGotRequiredParams ( eventIn ); 
	if (!err) done = true;
	return err;	
}


OSErr OpenAppl (AppleEvent *eventIn, long how)
{	FSSpec		file;
	AEDescList	docList;
	OSErr		err;
	long			index, itemsInList;
	Size			actualSize;
	AEKeyword	keywd;
	DescType	returnedType;
	err = AEGetParamDesc ( eventIn, keyDirectObject, typeAEList, &docList );
	if (err) return err; 
	err = MyGotRequiredParams ( eventIn );		
	if (!err) err = AECountItems ( &docList, &itemsInList );
	for (index=1; index<=itemsInList && !err; index++) 
	{	err = AEGetNthPtr ( &docList, index, typeFSS, &keywd, &returnedType, 
							(Ptr)&file, sizeof(file), &actualSize );
		if (!err && how=='ODOC') HandleOPEN ( file );
		if (!err && how=='PDOC') ShowHelp();
	}
	AEDisposeDesc(&docList);
	return err;
}


pascal OSErr HandleOpenDOC(AppleEvent *eventIn, AppleEvent *eventOut, long refCon)
{	return OpenAppl ( eventIn, 'ODOC' );  }

pascal OSErr HandlePrintDOC(AppleEvent *eventIn, AppleEvent *eventOut, long refCon)
{	return OpenAppl ( eventIn, 'PDOC' );  }


void InitHighLevelEvents()
{	if ( AEInstallEventHandler ( kCoreEventClass,'oapp',HandleOpenAPP,0L,false ) == noErr )
	if ( AEInstallEventHandler ( kCoreEventClass,'odoc',HandleOpenDOC,0L,false ) == noErr )
	if ( AEInstallEventHandler ( kCoreEventClass,'pdoc',HandlePrintDOC,0L,false ) == noErr )
	if ( AEInstallEventHandler ( kCoreEventClass,'quit',HandleQuitAPP,0L,false ) == noErr )
		return;
	DoAbort (	"\pApple event handlers could not be installed",
			"\pFehler beim Installieren eines AppleEvent-Handlers", "\p" );
}

